#ifndef SVEXCHANGE_H
#define SVEXCHANGE_H

#include <string>

namespace SVexchange {

	enum instruction {IDENT, STATUS, DATA, INIT, PARK, RUN, RUN_BKGR,
							STOP, STOP_NOW, QUIT, NEW_OBJECT, UNKNOWN};
	enum status {READY, PARKED, ERSYN, ERFAT, ERANG, BUSY, NOSTAR};

	const char* getNewObject(void);
	void setStatus(status stat);
	void setErstatus(status erstatus);
	void setData(const char* data);

	instruction translate(std::string& what, int& comid);

	int sendIdent(int comid);
	int sendStatus(int comid);
	int sendData(int comid);
	int sendOK(int comid, int waitsec);
	int sendError(int comid);
};

#endif
