#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <math.h>		// log10
#include "trbsocket.h"
#include "trbexport.h"
#include "names.h"
#include "tools.h"		// jdebug()
#include "success.h"	// SUCCESS/FAIL

using namespace std;

namespace trbsocket {
	struct sockaddr_in name;
	struct sockaddr_in clientName;
	FILE *sock_file = NULL;
	size_t size = sizeof(clientName);
	int mountSocket = -1;
	int clientSocket = -1;
	bool connection = false;

	string::size_type i0 = 0;
}

int trbsocket::init(void) {
	jdebug("trbsocket::init");

	sock_file = fopen("mass.log","a");
	name.sin_family = AF_INET;
	name.sin_port = htons(MOUNT_PORT);
	name.sin_addr.s_addr = htonl(INADDR_ANY);
	int sock = socket(PF_INET,SOCK_STREAM,0);
	if(sock < 0 ) {
		perror("server's socket");
		return FAIL;
	}
//	int flags = fcntl(sock, F_GETFL, 0);
//	fcntl(sock, F_SETFL, flags|O_NONBLOCK);
	if(bind(sock, (struct sockaddr*)&name, sizeof(name)) < 0) {
		perror ("bind");
        return FAIL;
    }
	if(listen(sock, 1) < 0) {
		perror("listen");
		return FAIL;
	}
	mountSocket = sock;
	atexit(closeSocket);
	return SUCCESS;
}

void trbsocket::closeSocket(void) {
	jdebug("trbsocket::closeSocket");
	if(sock_file) fclose(sock_file);
 	if(mountSocket > 0) if(close(mountSocket) < 0) perror("close mountSocket");
	if(clientSocket > 0) if(close(clientSocket) < 0) perror("close clientSocket");
}

int trbsocket::newConnection(void) {
	jdebug("trbsocket::newConnection");

	int newSock = accept(mountSocket, (struct sockaddr *)&clientName, &size);
	if(newSock < 0) {
//		if(errno == EAGAIN) return FAIL;
		perror ("accept");
		return FAIL;
	}
//	int flags = fcntl(newSock, F_GETFL, 0);
//	fcntl(newSock, F_SETFL, flags|O_NONBLOCK);
	clientSocket = newSock;
	if(sock_file) fprintf(sock_file, "Connect from host %s, port %hd.\n",
		inet_ntoa(clientName.sin_addr), ntohs(clientName.sin_port));
	connection = true;
	return(newSock);
}

int trbsocket::extractInstruction(int i) {
	i0 = string::size_type(i);
	return 0;
}

int trbsocket::extractInstruction(string from, string& instruction) {
	string::size_type i1 = from.find("\r\n",i0);
	if(i1 == string::npos) return 0;
	instruction = from.substr(i0,i1-i0);
	i0 = i1+2;	// pereskakivaem cherez "\r" i "\n"
	return i1;
}

const int max_length = 80;

int trbsocket::readCommand(void) {
	char str[max_length];
	int len = recv(clientSocket,str,max_length,0);
	if(len <= 0) {
		perror("server: recv");
		connection = false;
		close(clientSocket);
		clientSocket = -1;
		return FAIL;
	}
	str[len] = '\0';
	string instruction;
	extractInstruction(0);
	while(extractInstruction(str,instruction)) {
		if(sock_file) fprintf(sock_file,"<-%s\n",instruction.c_str());
		SVexport::set(instruction);
	}
	return SUCCESS;
}

int trbsocket::sendToSV(int comid, const char* mess) {
	char num[max_comid_len];
	sprintf(num,"%d ",comid);
	string toSV = num;
	toSV += mess;
	if(sock_file) fprintf(sock_file,"->%s",toSV.c_str());
	if( send(clientSocket,toSV.c_str(),strlen(toSV.c_str()),0) <= 0 ) {
		perror("server: send");
		return FAIL;
	}
	return SUCCESS;
}

int trbsocket::socket_cycle(void) {
	jdebug("trbsocket::socket_cycle");
	while(1) {
		if(connection) {
			readCommand();
		} else newConnection();
//		sleep(1);
	}
}
